# coding: utf-8

"""
    SEMP (Solace Element Management Protocol)

    SEMP (starting in `v2`, see note 1) is a RESTful API for configuring, monitoring, and administering a Solace PubSub+ broker.  SEMP uses URIs to address manageable **resources** of the Solace PubSub+ broker. Resources are individual **objects**, **collections** of objects, or (exclusively in the action API) **actions**. This document applies to the following API:   API|Base Path|Purpose|Comments :---|:---|:---|:--- Monitoring|/SEMP/v2/monitor|Querying operational parameters|See note 2    The following APIs are also available:   API|Base Path|Purpose|Comments :---|:---|:---|:--- Action|/SEMP/v2/action|Performing actions|See note 2 Configuration|/SEMP/v2/config|Reading and writing config state|See note 2    Resources are always nouns, with individual objects being singular and collections being plural.  Objects within a collection are identified by an `obj-id`, which follows the collection name with the form `collection-name/obj-id`.  Actions within an object are identified by an `action-id`, which follows the object name with the form `obj-id/action-id`.  Some examples:  ``` /SEMP/v2/config/msgVpns                        ; MsgVpn collection /SEMP/v2/config/msgVpns/a                      ; MsgVpn object named \"a\" /SEMP/v2/config/msgVpns/a/queues               ; Queue collection in MsgVpn \"a\" /SEMP/v2/config/msgVpns/a/queues/b             ; Queue object named \"b\" in MsgVpn \"a\" /SEMP/v2/action/msgVpns/a/queues/b/startReplay ; Action that starts a replay on Queue \"b\" in MsgVpn \"a\" /SEMP/v2/monitor/msgVpns/a/clients             ; Client collection in MsgVpn \"a\" /SEMP/v2/monitor/msgVpns/a/clients/c           ; Client object named \"c\" in MsgVpn \"a\" ```  ## Collection Resources  Collections are unordered lists of objects (unless described as otherwise), and are described by JSON arrays. Each item in the array represents an object in the same manner as the individual object would normally be represented. In the configuration API, the creation of a new object is done through its collection resource.  ## Object and Action Resources  Objects are composed of attributes, actions, collections, and other objects. They are described by JSON objects as name/value pairs. The collections and actions of an object are not contained directly in the object's JSON content; rather the content includes an attribute containing a URI which points to the collections and actions. These contained resources must be managed through this URI. At a minimum, every object has one or more identifying attributes, and its own `uri` attribute which contains the URI pointing to itself.  Actions are also composed of attributes, and are described by JSON objects as name/value pairs. Unlike objects, however, they are not members of a collection and cannot be retrieved, only performed. Actions only exist in the action API.  Attributes in an object or action may have any (non-exclusively) of the following properties:   Property|Meaning|Comments :---|:---|:--- Identifying|Attribute is involved in unique identification of the object, and appears in its URI| Required|Attribute must be provided in the request| Read-Only|Attribute can only be read, not written|See note 3 Write-Only|Attribute can only be written, not read| Requires-Disable|Attribute can only be changed when object is disabled| Deprecated|Attribute is deprecated, and will disappear in the next SEMP version|    In some requests, certain attributes may only be provided in certain combinations with other attributes:   Relationship|Meaning :---|:--- Requires|Attribute may only be changed by a request if a particular attribute or combination of attributes is also provided in the request Conflicts|Attribute may only be provided in a request if a particular attribute or combination of attributes is not also provided in the request    ## HTTP Methods  The following HTTP methods manipulate resources in accordance with these general principles. Note that some methods are only used in certain APIs:   Method|Resource|Meaning|Request Body|Response Body|Missing Request Attributes :---|:---|:---|:---|:---|:--- POST|Collection|Create object|Initial attribute values|Object attributes and metadata|Set to default PUT|Object|Create or replace object|New attribute values|Object attributes and metadata|Set to default (but see note 4) PUT|Action|Performs action|Action arguments|Action metadata|N/A PATCH|Object|Update object|New attribute values|Object attributes and metadata|unchanged DELETE|Object|Delete object|Empty|Object metadata|N/A GET|Object|Get object|Empty|Object attributes and metadata|N/A GET|Collection|Get collection|Empty|Object attributes and collection metadata|N/A    ## Common Query Parameters  The following are some common query parameters that are supported by many method/URI combinations. Individual URIs may document additional parameters. Note that multiple query parameters can be used together in a single URI, separated by the ampersand character. For example:  ``` ; Request for the MsgVpns collection using two hypothetical query parameters ; \"q1\" and \"q2\" with values \"val1\" and \"val2\" respectively /SEMP/v2/monitor/msgVpns?q1=val1&q2=val2 ```  ### select  Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. Use this query parameter to limit the size of the returned data for each returned object, return only those fields that are desired, or exclude fields that are not desired.  The value of `select` is a comma-separated list of attribute names. If the list contains attribute names that are not prefaced by `-`, only those attributes are included in the response. If the list contains attribute names that are prefaced by `-`, those attributes are excluded from the response. If the list contains both types, then the difference of the first set of attributes and the second set of attributes is returned. If the list is empty (i.e. `select=`), no attributes are returned.  All attributes that are prefaced by `-` must follow all attributes that are not prefaced by `-`. In addition, each attribute name in the list must match at least one attribute in the object.  Names may include the `*` wildcard (zero or more characters). Nested attribute names are supported using periods (e.g. `parentName.childName`).  Some examples:  ``` ; List of all MsgVpn names /SEMP/v2/monitor/msgVpns?select=msgVpnName ; List of all MsgVpn and their attributes except for their names /SEMP/v2/monitor/msgVpns?select=-msgVpnName ; Authentication attributes of MsgVpn \"finance\" /SEMP/v2/monitor/msgVpns/finance?select=authentication* ; All attributes of MsgVpn \"finance\" except for authentication attributes /SEMP/v2/monitor/msgVpns/finance?select=-authentication* ; Access related attributes of Queue \"orderQ\" of MsgVpn \"finance\" /SEMP/v2/monitor/msgVpns/finance/queues/orderQ?select=owner,permission ```  ### where  Include in the response only objects where certain conditions are true. Use this query parameter to limit which objects are returned to those whose attribute values meet the given conditions.  The value of `where` is a comma-separated list of expressions. All expressions must be true for the object to be included in the response. Each expression takes the form:  ``` expression  = attribute-name OP value OP          = '==' | '!=' | '&lt;' | '&gt;' | '&lt;=' | '&gt;=' ```  `value` may be a number, string, `true`, or `false`, as appropriate for the type of `attribute-name`. Greater-than and less-than comparisons only work for numbers. A `*` in a string `value` is interpreted as a wildcard (zero or more characters). Some examples:  ``` ; Only enabled MsgVpns /SEMP/v2/monitor/msgVpns?where=enabled==true ; Only MsgVpns using basic non-LDAP authentication /SEMP/v2/monitor/msgVpns?where=authenticationBasicEnabled==true,authenticationBasicType!=ldap ; Only MsgVpns that allow more than 100 client connections /SEMP/v2/monitor/msgVpns?where=maxConnectionCount>100 ; Only MsgVpns with msgVpnName starting with \"B\": /SEMP/v2/monitor/msgVpns?where=msgVpnName==B* ```  ### count  Limit the count of objects in the response. This can be useful to limit the size of the response for large collections. The minimum value for `count` is `1` and the default is `10`. There is also a per-collection maximum value to limit request handling time. For example:  ``` ; Up to 25 MsgVpns /SEMP/v2/monitor/msgVpns?count=25 ```  ### cursor  The cursor, or position, for the next page of objects. Cursors are opaque data that should not be created or interpreted by SEMP clients, and should only be used as described below.  When a request is made for a collection and there may be additional objects available for retrieval that are not included in the initial response, the response will include a `cursorQuery` field containing a cursor. The value of this field can be specified in the `cursor` query parameter of a subsequent request to retrieve the next page of objects. For convenience, an appropriate URI is constructed automatically by the broker and included in the `nextPageUri` field of the response. This URI can be used directly to retrieve the next page of objects.  ## Notes  Note|Description :---:|:--- 1|This specification defines SEMP starting in \"v2\", and not the original SEMP \"v1\" interface. Request and response formats between \"v1\" and \"v2\" are entirely incompatible, although both protocols share a common port configuration on the Solace PubSub+ broker. They are differentiated by the initial portion of the URI path, one of either \"/SEMP/\" or \"/SEMP/v2/\" 2|This API is partially implemented. Only a subset of all objects are available. 3|Read-only attributes may appear in POST and PUT/PATCH requests. However, if a read-only attribute is not marked as identifying, it will be ignored during a PUT/PATCH. 4|For PUT, if the SEMP user is not authorized to modify the attribute, its value is left unchanged rather than set to default. In addition, the values of write-only attributes are not set to their defaults on a PUT. If the object does not exist, it is created first.    # noqa: E501

    OpenAPI spec version: 2.16
    Contact: support@solace.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from solace_semp_monitor.api_client import ApiClient


class DmrClusterApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_dmr_cluster(self, dmr_cluster_name, **kwargs):  # noqa: E501
        """Get a Cluster object.  # noqa: E501

        Get a Cluster object.  A Cluster is a provisioned object on a message broker that contains global DMR configuration parameters.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster(dmr_cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dmr_cluster_with_http_info(dmr_cluster_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_dmr_cluster_with_http_info(dmr_cluster_name, **kwargs)  # noqa: E501
            return data

    def get_dmr_cluster_with_http_info(self, dmr_cluster_name, **kwargs):  # noqa: E501
        """Get a Cluster object.  # noqa: E501

        Get a Cluster object.  A Cluster is a provisioned object on a message broker that contains global DMR configuration parameters.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_with_http_info(dmr_cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dmr_cluster_name', 'select']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dmr_cluster" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dmr_cluster_name' is set
        if ('dmr_cluster_name' not in params or
                params['dmr_cluster_name'] is None):
            raise ValueError("Missing the required parameter `dmr_cluster_name` when calling `get_dmr_cluster`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'dmr_cluster_name' in params:
            path_params['dmrClusterName'] = params['dmr_cluster_name']  # noqa: E501

        query_params = []
        if 'select' in params:
            query_params.append(('select', params['select']))  # noqa: E501
            collection_formats['select'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/dmrClusters/{dmrClusterName}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DmrClusterResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_dmr_cluster_link(self, dmr_cluster_name, remote_node_name, **kwargs):  # noqa: E501
        """Get a Link object.  # noqa: E501

        Get a Link object.  A Link connects nodes (either within a Cluster or between two different Clusters) and allows them to exchange topology information, subscriptions and data.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x| remoteNodeName|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_link(dmr_cluster_name, remote_node_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param str remote_node_name: The name of the node at the remote end of the Link. (required)
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterLinkResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dmr_cluster_link_with_http_info(dmr_cluster_name, remote_node_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_dmr_cluster_link_with_http_info(dmr_cluster_name, remote_node_name, **kwargs)  # noqa: E501
            return data

    def get_dmr_cluster_link_with_http_info(self, dmr_cluster_name, remote_node_name, **kwargs):  # noqa: E501
        """Get a Link object.  # noqa: E501

        Get a Link object.  A Link connects nodes (either within a Cluster or between two different Clusters) and allows them to exchange topology information, subscriptions and data.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x| remoteNodeName|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_link_with_http_info(dmr_cluster_name, remote_node_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param str remote_node_name: The name of the node at the remote end of the Link. (required)
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterLinkResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dmr_cluster_name', 'remote_node_name', 'select']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dmr_cluster_link" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dmr_cluster_name' is set
        if ('dmr_cluster_name' not in params or
                params['dmr_cluster_name'] is None):
            raise ValueError("Missing the required parameter `dmr_cluster_name` when calling `get_dmr_cluster_link`")  # noqa: E501
        # verify the required parameter 'remote_node_name' is set
        if ('remote_node_name' not in params or
                params['remote_node_name'] is None):
            raise ValueError("Missing the required parameter `remote_node_name` when calling `get_dmr_cluster_link`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'dmr_cluster_name' in params:
            path_params['dmrClusterName'] = params['dmr_cluster_name']  # noqa: E501
        if 'remote_node_name' in params:
            path_params['remoteNodeName'] = params['remote_node_name']  # noqa: E501

        query_params = []
        if 'select' in params:
            query_params.append(('select', params['select']))  # noqa: E501
            collection_formats['select'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/dmrClusters/{dmrClusterName}/links/{remoteNodeName}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DmrClusterLinkResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_dmr_cluster_link_channel(self, dmr_cluster_name, remote_node_name, msg_vpn_name, **kwargs):  # noqa: E501
        """Get a Cluster Link Channels object.  # noqa: E501

        Get a Cluster Link Channels object.  A Channel is a connection between this broker and a remote node in the Cluster.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x| msgVpnName|x| remoteNodeName|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_link_channel(dmr_cluster_name, remote_node_name, msg_vpn_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param str remote_node_name: The name of the node at the remote end of the Link. (required)
        :param str msg_vpn_name: The name of the Message VPN. (required)
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterLinkChannelResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dmr_cluster_link_channel_with_http_info(dmr_cluster_name, remote_node_name, msg_vpn_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_dmr_cluster_link_channel_with_http_info(dmr_cluster_name, remote_node_name, msg_vpn_name, **kwargs)  # noqa: E501
            return data

    def get_dmr_cluster_link_channel_with_http_info(self, dmr_cluster_name, remote_node_name, msg_vpn_name, **kwargs):  # noqa: E501
        """Get a Cluster Link Channels object.  # noqa: E501

        Get a Cluster Link Channels object.  A Channel is a connection between this broker and a remote node in the Cluster.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x| msgVpnName|x| remoteNodeName|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_link_channel_with_http_info(dmr_cluster_name, remote_node_name, msg_vpn_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param str remote_node_name: The name of the node at the remote end of the Link. (required)
        :param str msg_vpn_name: The name of the Message VPN. (required)
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterLinkChannelResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dmr_cluster_name', 'remote_node_name', 'msg_vpn_name', 'select']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dmr_cluster_link_channel" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dmr_cluster_name' is set
        if ('dmr_cluster_name' not in params or
                params['dmr_cluster_name'] is None):
            raise ValueError("Missing the required parameter `dmr_cluster_name` when calling `get_dmr_cluster_link_channel`")  # noqa: E501
        # verify the required parameter 'remote_node_name' is set
        if ('remote_node_name' not in params or
                params['remote_node_name'] is None):
            raise ValueError("Missing the required parameter `remote_node_name` when calling `get_dmr_cluster_link_channel`")  # noqa: E501
        # verify the required parameter 'msg_vpn_name' is set
        if ('msg_vpn_name' not in params or
                params['msg_vpn_name'] is None):
            raise ValueError("Missing the required parameter `msg_vpn_name` when calling `get_dmr_cluster_link_channel`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'dmr_cluster_name' in params:
            path_params['dmrClusterName'] = params['dmr_cluster_name']  # noqa: E501
        if 'remote_node_name' in params:
            path_params['remoteNodeName'] = params['remote_node_name']  # noqa: E501
        if 'msg_vpn_name' in params:
            path_params['msgVpnName'] = params['msg_vpn_name']  # noqa: E501

        query_params = []
        if 'select' in params:
            query_params.append(('select', params['select']))  # noqa: E501
            collection_formats['select'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/dmrClusters/{dmrClusterName}/links/{remoteNodeName}/channels/{msgVpnName}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DmrClusterLinkChannelResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_dmr_cluster_link_channels(self, dmr_cluster_name, remote_node_name, **kwargs):  # noqa: E501
        """Get a list of Cluster Link Channels objects.  # noqa: E501

        Get a list of Cluster Link Channels objects.  A Channel is a connection between this broker and a remote node in the Cluster.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x| msgVpnName|x| remoteNodeName|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_link_channels(dmr_cluster_name, remote_node_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param str remote_node_name: The name of the node at the remote end of the Link. (required)
        :param int count: Limit the count of objects in the response. See the documentation for the `count` parameter.
        :param str cursor: The cursor, or position, for the next page of objects. See the documentation for the `cursor` parameter.
        :param list[str] where: Include in the response only objects where certain conditions are true. See the the documentation for the `where` parameter.
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterLinkChannelsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dmr_cluster_link_channels_with_http_info(dmr_cluster_name, remote_node_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_dmr_cluster_link_channels_with_http_info(dmr_cluster_name, remote_node_name, **kwargs)  # noqa: E501
            return data

    def get_dmr_cluster_link_channels_with_http_info(self, dmr_cluster_name, remote_node_name, **kwargs):  # noqa: E501
        """Get a list of Cluster Link Channels objects.  # noqa: E501

        Get a list of Cluster Link Channels objects.  A Channel is a connection between this broker and a remote node in the Cluster.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x| msgVpnName|x| remoteNodeName|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_link_channels_with_http_info(dmr_cluster_name, remote_node_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param str remote_node_name: The name of the node at the remote end of the Link. (required)
        :param int count: Limit the count of objects in the response. See the documentation for the `count` parameter.
        :param str cursor: The cursor, or position, for the next page of objects. See the documentation for the `cursor` parameter.
        :param list[str] where: Include in the response only objects where certain conditions are true. See the the documentation for the `where` parameter.
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterLinkChannelsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dmr_cluster_name', 'remote_node_name', 'count', 'cursor', 'where', 'select']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dmr_cluster_link_channels" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dmr_cluster_name' is set
        if ('dmr_cluster_name' not in params or
                params['dmr_cluster_name'] is None):
            raise ValueError("Missing the required parameter `dmr_cluster_name` when calling `get_dmr_cluster_link_channels`")  # noqa: E501
        # verify the required parameter 'remote_node_name' is set
        if ('remote_node_name' not in params or
                params['remote_node_name'] is None):
            raise ValueError("Missing the required parameter `remote_node_name` when calling `get_dmr_cluster_link_channels`")  # noqa: E501

        if 'count' in params and params['count'] < 1:  # noqa: E501
            raise ValueError("Invalid value for parameter `count` when calling `get_dmr_cluster_link_channels`, must be a value greater than or equal to `1`")  # noqa: E501
        collection_formats = {}

        path_params = {}
        if 'dmr_cluster_name' in params:
            path_params['dmrClusterName'] = params['dmr_cluster_name']  # noqa: E501
        if 'remote_node_name' in params:
            path_params['remoteNodeName'] = params['remote_node_name']  # noqa: E501

        query_params = []
        if 'count' in params:
            query_params.append(('count', params['count']))  # noqa: E501
        if 'cursor' in params:
            query_params.append(('cursor', params['cursor']))  # noqa: E501
        if 'where' in params:
            query_params.append(('where', params['where']))  # noqa: E501
            collection_formats['where'] = 'csv'  # noqa: E501
        if 'select' in params:
            query_params.append(('select', params['select']))  # noqa: E501
            collection_formats['select'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/dmrClusters/{dmrClusterName}/links/{remoteNodeName}/channels', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DmrClusterLinkChannelsResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_dmr_cluster_link_remote_address(self, dmr_cluster_name, remote_node_name, remote_address, **kwargs):  # noqa: E501
        """Get a Remote Address object.  # noqa: E501

        Get a Remote Address object.  Each Remote Address, consisting of a FQDN or IP address and optional port, is used to connect to the remote node for this Link. Up to 4 addresses may be provided for each Link, and will be tried on a round-robin basis.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x| remoteAddress|x| remoteNodeName|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_link_remote_address(dmr_cluster_name, remote_node_name, remote_address, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param str remote_node_name: The name of the node at the remote end of the Link. (required)
        :param str remote_address: The FQDN or IP address (and optional port) of the remote node. If a port is not provided, it will vary based on the transport encoding: 55555 (plain-text), 55443 (encrypted), or 55003 (compressed). (required)
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterLinkRemoteAddressResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dmr_cluster_link_remote_address_with_http_info(dmr_cluster_name, remote_node_name, remote_address, **kwargs)  # noqa: E501
        else:
            (data) = self.get_dmr_cluster_link_remote_address_with_http_info(dmr_cluster_name, remote_node_name, remote_address, **kwargs)  # noqa: E501
            return data

    def get_dmr_cluster_link_remote_address_with_http_info(self, dmr_cluster_name, remote_node_name, remote_address, **kwargs):  # noqa: E501
        """Get a Remote Address object.  # noqa: E501

        Get a Remote Address object.  Each Remote Address, consisting of a FQDN or IP address and optional port, is used to connect to the remote node for this Link. Up to 4 addresses may be provided for each Link, and will be tried on a round-robin basis.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x| remoteAddress|x| remoteNodeName|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_link_remote_address_with_http_info(dmr_cluster_name, remote_node_name, remote_address, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param str remote_node_name: The name of the node at the remote end of the Link. (required)
        :param str remote_address: The FQDN or IP address (and optional port) of the remote node. If a port is not provided, it will vary based on the transport encoding: 55555 (plain-text), 55443 (encrypted), or 55003 (compressed). (required)
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterLinkRemoteAddressResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dmr_cluster_name', 'remote_node_name', 'remote_address', 'select']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dmr_cluster_link_remote_address" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dmr_cluster_name' is set
        if ('dmr_cluster_name' not in params or
                params['dmr_cluster_name'] is None):
            raise ValueError("Missing the required parameter `dmr_cluster_name` when calling `get_dmr_cluster_link_remote_address`")  # noqa: E501
        # verify the required parameter 'remote_node_name' is set
        if ('remote_node_name' not in params or
                params['remote_node_name'] is None):
            raise ValueError("Missing the required parameter `remote_node_name` when calling `get_dmr_cluster_link_remote_address`")  # noqa: E501
        # verify the required parameter 'remote_address' is set
        if ('remote_address' not in params or
                params['remote_address'] is None):
            raise ValueError("Missing the required parameter `remote_address` when calling `get_dmr_cluster_link_remote_address`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'dmr_cluster_name' in params:
            path_params['dmrClusterName'] = params['dmr_cluster_name']  # noqa: E501
        if 'remote_node_name' in params:
            path_params['remoteNodeName'] = params['remote_node_name']  # noqa: E501
        if 'remote_address' in params:
            path_params['remoteAddress'] = params['remote_address']  # noqa: E501

        query_params = []
        if 'select' in params:
            query_params.append(('select', params['select']))  # noqa: E501
            collection_formats['select'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/dmrClusters/{dmrClusterName}/links/{remoteNodeName}/remoteAddresses/{remoteAddress}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DmrClusterLinkRemoteAddressResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_dmr_cluster_link_remote_addresses(self, dmr_cluster_name, remote_node_name, **kwargs):  # noqa: E501
        """Get a list of Remote Address objects.  # noqa: E501

        Get a list of Remote Address objects.  Each Remote Address, consisting of a FQDN or IP address and optional port, is used to connect to the remote node for this Link. Up to 4 addresses may be provided for each Link, and will be tried on a round-robin basis.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x| remoteAddress|x| remoteNodeName|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_link_remote_addresses(dmr_cluster_name, remote_node_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param str remote_node_name: The name of the node at the remote end of the Link. (required)
        :param list[str] where: Include in the response only objects where certain conditions are true. See the the documentation for the `where` parameter.
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterLinkRemoteAddressesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dmr_cluster_link_remote_addresses_with_http_info(dmr_cluster_name, remote_node_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_dmr_cluster_link_remote_addresses_with_http_info(dmr_cluster_name, remote_node_name, **kwargs)  # noqa: E501
            return data

    def get_dmr_cluster_link_remote_addresses_with_http_info(self, dmr_cluster_name, remote_node_name, **kwargs):  # noqa: E501
        """Get a list of Remote Address objects.  # noqa: E501

        Get a list of Remote Address objects.  Each Remote Address, consisting of a FQDN or IP address and optional port, is used to connect to the remote node for this Link. Up to 4 addresses may be provided for each Link, and will be tried on a round-robin basis.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x| remoteAddress|x| remoteNodeName|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_link_remote_addresses_with_http_info(dmr_cluster_name, remote_node_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param str remote_node_name: The name of the node at the remote end of the Link. (required)
        :param list[str] where: Include in the response only objects where certain conditions are true. See the the documentation for the `where` parameter.
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterLinkRemoteAddressesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dmr_cluster_name', 'remote_node_name', 'where', 'select']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dmr_cluster_link_remote_addresses" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dmr_cluster_name' is set
        if ('dmr_cluster_name' not in params or
                params['dmr_cluster_name'] is None):
            raise ValueError("Missing the required parameter `dmr_cluster_name` when calling `get_dmr_cluster_link_remote_addresses`")  # noqa: E501
        # verify the required parameter 'remote_node_name' is set
        if ('remote_node_name' not in params or
                params['remote_node_name'] is None):
            raise ValueError("Missing the required parameter `remote_node_name` when calling `get_dmr_cluster_link_remote_addresses`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'dmr_cluster_name' in params:
            path_params['dmrClusterName'] = params['dmr_cluster_name']  # noqa: E501
        if 'remote_node_name' in params:
            path_params['remoteNodeName'] = params['remote_node_name']  # noqa: E501

        query_params = []
        if 'where' in params:
            query_params.append(('where', params['where']))  # noqa: E501
            collection_formats['where'] = 'csv'  # noqa: E501
        if 'select' in params:
            query_params.append(('select', params['select']))  # noqa: E501
            collection_formats['select'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/dmrClusters/{dmrClusterName}/links/{remoteNodeName}/remoteAddresses', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DmrClusterLinkRemoteAddressesResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_dmr_cluster_link_tls_trusted_common_name(self, dmr_cluster_name, remote_node_name, tls_trusted_common_name, **kwargs):  # noqa: E501
        """Get a Trusted Common Name object.  # noqa: E501

        Get a Trusted Common Name object.  The Trusted Common Names for the Link are used by encrypted transports to verify the name in the certificate presented by the remote node. They must include the common name of the remote node's server certificate or client certificate, depending upon the initiator of the connection.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x| remoteNodeName|x| tlsTrustedCommonName|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_link_tls_trusted_common_name(dmr_cluster_name, remote_node_name, tls_trusted_common_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param str remote_node_name: The name of the node at the remote end of the Link. (required)
        :param str tls_trusted_common_name: The expected trusted common name of the remote certificate. (required)
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterLinkTlsTrustedCommonNameResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dmr_cluster_link_tls_trusted_common_name_with_http_info(dmr_cluster_name, remote_node_name, tls_trusted_common_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_dmr_cluster_link_tls_trusted_common_name_with_http_info(dmr_cluster_name, remote_node_name, tls_trusted_common_name, **kwargs)  # noqa: E501
            return data

    def get_dmr_cluster_link_tls_trusted_common_name_with_http_info(self, dmr_cluster_name, remote_node_name, tls_trusted_common_name, **kwargs):  # noqa: E501
        """Get a Trusted Common Name object.  # noqa: E501

        Get a Trusted Common Name object.  The Trusted Common Names for the Link are used by encrypted transports to verify the name in the certificate presented by the remote node. They must include the common name of the remote node's server certificate or client certificate, depending upon the initiator of the connection.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x| remoteNodeName|x| tlsTrustedCommonName|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_link_tls_trusted_common_name_with_http_info(dmr_cluster_name, remote_node_name, tls_trusted_common_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param str remote_node_name: The name of the node at the remote end of the Link. (required)
        :param str tls_trusted_common_name: The expected trusted common name of the remote certificate. (required)
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterLinkTlsTrustedCommonNameResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dmr_cluster_name', 'remote_node_name', 'tls_trusted_common_name', 'select']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dmr_cluster_link_tls_trusted_common_name" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dmr_cluster_name' is set
        if ('dmr_cluster_name' not in params or
                params['dmr_cluster_name'] is None):
            raise ValueError("Missing the required parameter `dmr_cluster_name` when calling `get_dmr_cluster_link_tls_trusted_common_name`")  # noqa: E501
        # verify the required parameter 'remote_node_name' is set
        if ('remote_node_name' not in params or
                params['remote_node_name'] is None):
            raise ValueError("Missing the required parameter `remote_node_name` when calling `get_dmr_cluster_link_tls_trusted_common_name`")  # noqa: E501
        # verify the required parameter 'tls_trusted_common_name' is set
        if ('tls_trusted_common_name' not in params or
                params['tls_trusted_common_name'] is None):
            raise ValueError("Missing the required parameter `tls_trusted_common_name` when calling `get_dmr_cluster_link_tls_trusted_common_name`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'dmr_cluster_name' in params:
            path_params['dmrClusterName'] = params['dmr_cluster_name']  # noqa: E501
        if 'remote_node_name' in params:
            path_params['remoteNodeName'] = params['remote_node_name']  # noqa: E501
        if 'tls_trusted_common_name' in params:
            path_params['tlsTrustedCommonName'] = params['tls_trusted_common_name']  # noqa: E501

        query_params = []
        if 'select' in params:
            query_params.append(('select', params['select']))  # noqa: E501
            collection_formats['select'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/dmrClusters/{dmrClusterName}/links/{remoteNodeName}/tlsTrustedCommonNames/{tlsTrustedCommonName}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DmrClusterLinkTlsTrustedCommonNameResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_dmr_cluster_link_tls_trusted_common_names(self, dmr_cluster_name, remote_node_name, **kwargs):  # noqa: E501
        """Get a list of Trusted Common Name objects.  # noqa: E501

        Get a list of Trusted Common Name objects.  The Trusted Common Names for the Link are used by encrypted transports to verify the name in the certificate presented by the remote node. They must include the common name of the remote node's server certificate or client certificate, depending upon the initiator of the connection.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x| remoteNodeName|x| tlsTrustedCommonName|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_link_tls_trusted_common_names(dmr_cluster_name, remote_node_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param str remote_node_name: The name of the node at the remote end of the Link. (required)
        :param list[str] where: Include in the response only objects where certain conditions are true. See the the documentation for the `where` parameter.
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterLinkTlsTrustedCommonNamesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dmr_cluster_link_tls_trusted_common_names_with_http_info(dmr_cluster_name, remote_node_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_dmr_cluster_link_tls_trusted_common_names_with_http_info(dmr_cluster_name, remote_node_name, **kwargs)  # noqa: E501
            return data

    def get_dmr_cluster_link_tls_trusted_common_names_with_http_info(self, dmr_cluster_name, remote_node_name, **kwargs):  # noqa: E501
        """Get a list of Trusted Common Name objects.  # noqa: E501

        Get a list of Trusted Common Name objects.  The Trusted Common Names for the Link are used by encrypted transports to verify the name in the certificate presented by the remote node. They must include the common name of the remote node's server certificate or client certificate, depending upon the initiator of the connection.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x| remoteNodeName|x| tlsTrustedCommonName|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_link_tls_trusted_common_names_with_http_info(dmr_cluster_name, remote_node_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param str remote_node_name: The name of the node at the remote end of the Link. (required)
        :param list[str] where: Include in the response only objects where certain conditions are true. See the the documentation for the `where` parameter.
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterLinkTlsTrustedCommonNamesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dmr_cluster_name', 'remote_node_name', 'where', 'select']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dmr_cluster_link_tls_trusted_common_names" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dmr_cluster_name' is set
        if ('dmr_cluster_name' not in params or
                params['dmr_cluster_name'] is None):
            raise ValueError("Missing the required parameter `dmr_cluster_name` when calling `get_dmr_cluster_link_tls_trusted_common_names`")  # noqa: E501
        # verify the required parameter 'remote_node_name' is set
        if ('remote_node_name' not in params or
                params['remote_node_name'] is None):
            raise ValueError("Missing the required parameter `remote_node_name` when calling `get_dmr_cluster_link_tls_trusted_common_names`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'dmr_cluster_name' in params:
            path_params['dmrClusterName'] = params['dmr_cluster_name']  # noqa: E501
        if 'remote_node_name' in params:
            path_params['remoteNodeName'] = params['remote_node_name']  # noqa: E501

        query_params = []
        if 'where' in params:
            query_params.append(('where', params['where']))  # noqa: E501
            collection_formats['where'] = 'csv'  # noqa: E501
        if 'select' in params:
            query_params.append(('select', params['select']))  # noqa: E501
            collection_formats['select'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/dmrClusters/{dmrClusterName}/links/{remoteNodeName}/tlsTrustedCommonNames', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DmrClusterLinkTlsTrustedCommonNamesResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_dmr_cluster_links(self, dmr_cluster_name, **kwargs):  # noqa: E501
        """Get a list of Link objects.  # noqa: E501

        Get a list of Link objects.  A Link connects nodes (either within a Cluster or between two different Clusters) and allows them to exchange topology information, subscriptions and data.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x| remoteNodeName|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_links(dmr_cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param int count: Limit the count of objects in the response. See the documentation for the `count` parameter.
        :param str cursor: The cursor, or position, for the next page of objects. See the documentation for the `cursor` parameter.
        :param list[str] where: Include in the response only objects where certain conditions are true. See the the documentation for the `where` parameter.
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterLinksResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dmr_cluster_links_with_http_info(dmr_cluster_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_dmr_cluster_links_with_http_info(dmr_cluster_name, **kwargs)  # noqa: E501
            return data

    def get_dmr_cluster_links_with_http_info(self, dmr_cluster_name, **kwargs):  # noqa: E501
        """Get a list of Link objects.  # noqa: E501

        Get a list of Link objects.  A Link connects nodes (either within a Cluster or between two different Clusters) and allows them to exchange topology information, subscriptions and data.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x| remoteNodeName|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_links_with_http_info(dmr_cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param int count: Limit the count of objects in the response. See the documentation for the `count` parameter.
        :param str cursor: The cursor, or position, for the next page of objects. See the documentation for the `cursor` parameter.
        :param list[str] where: Include in the response only objects where certain conditions are true. See the the documentation for the `where` parameter.
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterLinksResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dmr_cluster_name', 'count', 'cursor', 'where', 'select']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dmr_cluster_links" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dmr_cluster_name' is set
        if ('dmr_cluster_name' not in params or
                params['dmr_cluster_name'] is None):
            raise ValueError("Missing the required parameter `dmr_cluster_name` when calling `get_dmr_cluster_links`")  # noqa: E501

        if 'count' in params and params['count'] < 1:  # noqa: E501
            raise ValueError("Invalid value for parameter `count` when calling `get_dmr_cluster_links`, must be a value greater than or equal to `1`")  # noqa: E501
        collection_formats = {}

        path_params = {}
        if 'dmr_cluster_name' in params:
            path_params['dmrClusterName'] = params['dmr_cluster_name']  # noqa: E501

        query_params = []
        if 'count' in params:
            query_params.append(('count', params['count']))  # noqa: E501
        if 'cursor' in params:
            query_params.append(('cursor', params['cursor']))  # noqa: E501
        if 'where' in params:
            query_params.append(('where', params['where']))  # noqa: E501
            collection_formats['where'] = 'csv'  # noqa: E501
        if 'select' in params:
            query_params.append(('select', params['select']))  # noqa: E501
            collection_formats['select'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/dmrClusters/{dmrClusterName}/links', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DmrClusterLinksResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_dmr_cluster_topology_issue(self, dmr_cluster_name, topology_issue, **kwargs):  # noqa: E501
        """Get a Cluster Topology Issue object.  # noqa: E501

        Get a Cluster Topology Issue object.  A Cluster Topology Issue indicates incorrect or inconsistent configuration within the DMR network. Such issues will cause messages to be misdelivered or lost.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x| topologyIssue|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_topology_issue(dmr_cluster_name, topology_issue, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param str topology_issue: The topology issue discovered in the Cluster. A topology issue indicates incorrect or inconsistent configuration within the DMR network. Such issues will cause messages to be misdelivered or lost. (required)
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterTopologyIssueResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dmr_cluster_topology_issue_with_http_info(dmr_cluster_name, topology_issue, **kwargs)  # noqa: E501
        else:
            (data) = self.get_dmr_cluster_topology_issue_with_http_info(dmr_cluster_name, topology_issue, **kwargs)  # noqa: E501
            return data

    def get_dmr_cluster_topology_issue_with_http_info(self, dmr_cluster_name, topology_issue, **kwargs):  # noqa: E501
        """Get a Cluster Topology Issue object.  # noqa: E501

        Get a Cluster Topology Issue object.  A Cluster Topology Issue indicates incorrect or inconsistent configuration within the DMR network. Such issues will cause messages to be misdelivered or lost.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x| topologyIssue|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_topology_issue_with_http_info(dmr_cluster_name, topology_issue, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param str topology_issue: The topology issue discovered in the Cluster. A topology issue indicates incorrect or inconsistent configuration within the DMR network. Such issues will cause messages to be misdelivered or lost. (required)
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterTopologyIssueResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dmr_cluster_name', 'topology_issue', 'select']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dmr_cluster_topology_issue" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dmr_cluster_name' is set
        if ('dmr_cluster_name' not in params or
                params['dmr_cluster_name'] is None):
            raise ValueError("Missing the required parameter `dmr_cluster_name` when calling `get_dmr_cluster_topology_issue`")  # noqa: E501
        # verify the required parameter 'topology_issue' is set
        if ('topology_issue' not in params or
                params['topology_issue'] is None):
            raise ValueError("Missing the required parameter `topology_issue` when calling `get_dmr_cluster_topology_issue`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'dmr_cluster_name' in params:
            path_params['dmrClusterName'] = params['dmr_cluster_name']  # noqa: E501
        if 'topology_issue' in params:
            path_params['topologyIssue'] = params['topology_issue']  # noqa: E501

        query_params = []
        if 'select' in params:
            query_params.append(('select', params['select']))  # noqa: E501
            collection_formats['select'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/dmrClusters/{dmrClusterName}/topologyIssues/{topologyIssue}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DmrClusterTopologyIssueResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_dmr_cluster_topology_issues(self, dmr_cluster_name, **kwargs):  # noqa: E501
        """Get a list of Cluster Topology Issue objects.  # noqa: E501

        Get a list of Cluster Topology Issue objects.  A Cluster Topology Issue indicates incorrect or inconsistent configuration within the DMR network. Such issues will cause messages to be misdelivered or lost.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x| topologyIssue|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_topology_issues(dmr_cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param int count: Limit the count of objects in the response. See the documentation for the `count` parameter.
        :param str cursor: The cursor, or position, for the next page of objects. See the documentation for the `cursor` parameter.
        :param list[str] where: Include in the response only objects where certain conditions are true. See the the documentation for the `where` parameter.
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterTopologyIssuesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dmr_cluster_topology_issues_with_http_info(dmr_cluster_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_dmr_cluster_topology_issues_with_http_info(dmr_cluster_name, **kwargs)  # noqa: E501
            return data

    def get_dmr_cluster_topology_issues_with_http_info(self, dmr_cluster_name, **kwargs):  # noqa: E501
        """Get a list of Cluster Topology Issue objects.  # noqa: E501

        Get a list of Cluster Topology Issue objects.  A Cluster Topology Issue indicates incorrect or inconsistent configuration within the DMR network. Such issues will cause messages to be misdelivered or lost.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x| topologyIssue|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_cluster_topology_issues_with_http_info(dmr_cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dmr_cluster_name: The name of the Cluster. (required)
        :param int count: Limit the count of objects in the response. See the documentation for the `count` parameter.
        :param str cursor: The cursor, or position, for the next page of objects. See the documentation for the `cursor` parameter.
        :param list[str] where: Include in the response only objects where certain conditions are true. See the the documentation for the `where` parameter.
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClusterTopologyIssuesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dmr_cluster_name', 'count', 'cursor', 'where', 'select']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dmr_cluster_topology_issues" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dmr_cluster_name' is set
        if ('dmr_cluster_name' not in params or
                params['dmr_cluster_name'] is None):
            raise ValueError("Missing the required parameter `dmr_cluster_name` when calling `get_dmr_cluster_topology_issues`")  # noqa: E501

        if 'count' in params and params['count'] < 1:  # noqa: E501
            raise ValueError("Invalid value for parameter `count` when calling `get_dmr_cluster_topology_issues`, must be a value greater than or equal to `1`")  # noqa: E501
        collection_formats = {}

        path_params = {}
        if 'dmr_cluster_name' in params:
            path_params['dmrClusterName'] = params['dmr_cluster_name']  # noqa: E501

        query_params = []
        if 'count' in params:
            query_params.append(('count', params['count']))  # noqa: E501
        if 'cursor' in params:
            query_params.append(('cursor', params['cursor']))  # noqa: E501
        if 'where' in params:
            query_params.append(('where', params['where']))  # noqa: E501
            collection_formats['where'] = 'csv'  # noqa: E501
        if 'select' in params:
            query_params.append(('select', params['select']))  # noqa: E501
            collection_formats['select'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/dmrClusters/{dmrClusterName}/topologyIssues', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DmrClusterTopologyIssuesResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_dmr_clusters(self, **kwargs):  # noqa: E501
        """Get a list of Cluster objects.  # noqa: E501

        Get a list of Cluster objects.  A Cluster is a provisioned object on a message broker that contains global DMR configuration parameters.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_clusters(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int count: Limit the count of objects in the response. See the documentation for the `count` parameter.
        :param str cursor: The cursor, or position, for the next page of objects. See the documentation for the `cursor` parameter.
        :param list[str] where: Include in the response only objects where certain conditions are true. See the the documentation for the `where` parameter.
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClustersResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dmr_clusters_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_dmr_clusters_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_dmr_clusters_with_http_info(self, **kwargs):  # noqa: E501
        """Get a list of Cluster objects.  # noqa: E501

        Get a list of Cluster objects.  A Cluster is a provisioned object on a message broker that contains global DMR configuration parameters.   Attribute|Identifying|Deprecated :---|:---:|:---: dmrClusterName|x|    A SEMP client authorized with a minimum access scope/level of \"global/read-only\" is required to perform this operation.  This has been available since 2.11.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dmr_clusters_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int count: Limit the count of objects in the response. See the documentation for the `count` parameter.
        :param str cursor: The cursor, or position, for the next page of objects. See the documentation for the `cursor` parameter.
        :param list[str] where: Include in the response only objects where certain conditions are true. See the the documentation for the `where` parameter.
        :param list[str] select: Include in the response only selected attributes of the object, or exclude from the response selected attributes of the object. See the documentation for the `select` parameter.
        :return: DmrClustersResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['count', 'cursor', 'where', 'select']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dmr_clusters" % key
                )
            params[key] = val
        del params['kwargs']

        if 'count' in params and params['count'] < 1:  # noqa: E501
            raise ValueError("Invalid value for parameter `count` when calling `get_dmr_clusters`, must be a value greater than or equal to `1`")  # noqa: E501
        collection_formats = {}

        path_params = {}

        query_params = []
        if 'count' in params:
            query_params.append(('count', params['count']))  # noqa: E501
        if 'cursor' in params:
            query_params.append(('cursor', params['cursor']))  # noqa: E501
        if 'where' in params:
            query_params.append(('where', params['where']))  # noqa: E501
            collection_formats['where'] = 'csv'  # noqa: E501
        if 'select' in params:
            query_params.append(('select', params['select']))  # noqa: E501
            collection_formats['select'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/dmrClusters', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DmrClustersResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
